﻿'use strict';

console.log(version());

var spawn_points = [
	
	{name: 'restourant',		coords: [57.37,  82.86, 2.0], heading: 233.0},
	{name: 'office building',	coords: [31.31,  91.65, 2.0], heading: 51.0},
	{name: 'trash house',		coords: [72.3,   81.22, 2.0], heading: 223.0},
	{name: 'work zone',			coords: [112.28, 82.11, 2.0], heading: 90.0}, // actual z = 1.5
	
	// TEST AREA:
	//{name: 'work zone',			coords: [114.28 + 5 + 2 + 5, 92.11 + 5 + 2 + 0.1 + 1, 2.0], heading: 90.0}, // actual z = 1.5
	
	//{name: 'test zone',			coords: [127.5, 74.5, 2.0], heading: -90.0} // actual z = 1.5
	
	//{name: 'Test area',			coords: [128.28, 76.11, 2.5], heading: 90.0}
	
];

var game_interface = NewGameInstance();

game_interface.OnCreatePlayer = function(Player) {
	
	console.log('OnCreatePlayer: name: ' + Player.playername);
	
	Player.DamageType = null;
	// todo..maybe this should have been Player.last_damage = null;
	Player.spawn(true); // sets stuff
	
	if (Player.IsLocal == 1) { // if local player, create a car to play with.
		
		var somecar = new Vehicle('four', 54.77, 91.37, 2, 90 + 45); //
		
		/*
		var info = somecar.Get_Controlling_Actor();
		
		console.log('Get_Controlling_Actor');
		console.log(info);
		
		Player.EnterThisVehicle(somecar, false, true, -1);
		
		var info = somecar.Get_Controlling_Actor();
		
		console.log('Get_Controlling_Actor');
		console.log(info);
		console.log(info.playername);
		*/
		
		//var newt = new Trigger('rat4', 55.77, 91.37, 2, 20, 0.0);
		
		// ApplyDamage (bywho: Actor,FromWorld: x,FromWorld: y,FromWorld: z,amout: single,damagetype: tdamagetype)
		
	}
	
	// Player.health = 1.0; // default test
	
	Player.EchoMessage('{color:FFC518}Top down city test! ' + '{color:00FFFF}Enjoy!', constants.fontSize.font_b);
	
}

game_interface.OnDestroyPlayer = function(Player, Reason) {
	
	//console.log('OnDestroyPlayer');
	//console.log(Player.playername);
	
	if (Player.IsPlayer == false)
		return;
	
	if (Player.IsLocal == 1) {
		
		console.log('game shutting down.');
		
	} else {
		
		console.log('Player disconnected: ' + constants.disconnectReason.toString(Reason));
		
	}
	
}

game_interface.OnModeChange = function() {
	
	console.log('engine mode has changed to: ' + constants.engineState.toString(game_interface.EngineMode) + ' (' + game_interface.EngineMode + ')');
	
}

game_interface.OnDamagePlayer = function(Actor_Victim, Actor_Attacker, HitOrigin, OldHealth, NewHealth, DamageType) {
	
	//Actor_Victim.last_damage = DamageType;
	
	if (NewHealth == 0) {
		
		// OK:
		// console.log('KILL ' + (Actor_Victim == null ? "Unknown victim" : Actor_Victim.playername) + ' was damaged by ' + (Actor_Attacker == null ? "AI" : Actor_Attacker.playername) /*+ ' (' + OldHealth + ' -> ' + NewHealth + ') ' + constants.damageType.toString(DamageType)*/);
		
		if (Actor_Victim != null) {
			if (Actor_Victim.playername == 'Asshole') {
				
				/*
				var listk = SysGame.ActorList();
				//console.log(listk);
				
				for (var i in listk) {
					
					var ecto = listk[i];
					
					//console.log('returned actor: ' + ecto.playername);
					
				}
				*/
				
				Game.DeleteActor(Actor_Victim);
				
			}
		}
		
	} else {
		
		// OK:
		// console.log('Damage ' + (Actor_Victim == null ? "Unknown victim" : Actor_Victim.playername) + ' was damaged by ' + (Actor_Attacker == null ? "AI" : Actor_Attacker.playername) + ' (' + OldHealth + ' -> ' + NewHealth + ') ' + constants.damageType.toString(DamageType));
		
	}
	
}

game_interface.OnTick = function() {
	
	//console.log("OnTick.");
	
	for (var i in actor_stack) {
		
		var Player = actor_stack[i];
		
		if (Player.IsPlayer == false) continue;
		
		if (Player.health <= 0) {
			
			if (Player.DeadTime < 3000) // 3 seconds delay
				continue;
			
			if (game_interface.TimeDifference(Player.respawntime, game_interface.Time) < 1000) // prevent double calls - give it a chance to sync with main script.
				continue;
			
			var playerpos = Player.GetLocation();
			var playerpos_block = Player.GetBlockLocation();
			
			console.log("Player " + i + " has died at " + playerpos.x + ", " + playerpos.y + ", " + playerpos.z + " block " + playerpos_block.x + ", " + playerpos_block.y + ", " + playerpos_block.z + " and has been respawned.");
			
			// (' + constants.damageType.toString(Player.DamageType) + ')
			
			Player.EchoMessage('{color:FF0000}Died & {color:FFFFFF}Respawned!', constants.fontSize.font_b);
			
			Player.spawn(true);
			
		}
		
	}
	
}

// todo: should be global.console and prototyped from that.

Actor.spawn = function(position_too) {
	
	this.health = 100;
	
	//console.log(this.WeaponData());
	
	// todo: pick a random place to spawn.
	
	this.StripWeapons();
	this.GiveWeapon('gun1', 5000);
	this.GiveWeapon('molt', 5000);
	
	this.GiveWeapon('rat4', 5000);
	
	this.GiveWeapon('flam', 5000);
	
	this.GiveWeapon('gren', 5000);
	
	//this.GiveWeapon('banana', 5000);
	//this.GiveWeapon('hhg', 5000);
	
	
	//this.GiveWeapon('m4gl', 5000);
	
	
	//this.GiveWeapon('frce', 5000); // force fan
	
	
	//this.GiveWeapon('rat4', 5000);
	
	//this.GiveWeapon('flam', 5000);
	
	//this.GiveWeapon('sgun', 5000);
	
	
	var spawn_point = getRandomInt(spawn_points.length);
	
	// spawn_point = 3;
	
	if (position_too == true) {
		
		this.move(spawn_points[spawn_point].coords[0], spawn_points[spawn_point].coords[1], spawn_points[spawn_point].coords[2], true);
		this.heading = spawn_points[spawn_point].heading;
		
	}
	
	this.WantedLevel = 0;
	
	this.State = constants.actorState.AsNormal; // this could be a problem causing clients not to respawn properly.
	this.ExtinguishFires();
	this.SetActorAnimation(constants.animation.anm_stand, false, false, true);
	this.NetworkSync(); // Synchronize player over network, if remote player.
	
	this.ResetCamera(spawn_points[spawn_point].coords[0], spawn_points[spawn_point].coords[1], spawn_points[spawn_point].coords[2]); // reset the camera.
	
	this.respawntime = game_interface.Time;
	
	// create test character
	
	/*
	var tempactor = Game.NewActor(2, constants.aiClass.AI_ZOMBIE, spawn_points[spawn_point].coords[0], spawn_points[spawn_point].coords[1] + 1.0, spawn_points[spawn_point].coords[2], 45, 4);
	
	tempactor.playername = 'Asshole';
	
	// tempactor.GiveWeapon('gun1', 5000);
	tempactor.Attack(this, constants.aiClass.AI_IDIOTKILLER);
	*/
	
}

var somecar = new Vehicle('tank', 53.5, 89.5, 2, 45);
//var info = somecar.Get_Controlling_Actor();

//somecar.ShootFromTurret(actor_stack[0]);

//somecar.free();
/**somecar = null; // free?

/*

//console.log(somecar.health);
somecar.health = 10;
//console.log(somecar.health);

somecar.move(53.5, 89.5, 2, 45);

*/

/*var myseats = somecar.seats();
console.log(typeof myseats);
console.log(myseats);*/

//somecar.free();
//console.log('valid: ' + somecar.valid());

/*
var loop = function() {
	
}
*/
